{$E wdx}
{$IFDEF WIN64}
  {$E w64}
  {$IFNDEF VER230}
    {$E wdx64}
  {$ENDIF}
{$ENDIF}

{$WEAKLINKRTTI ON}

library UnicodeTestEx;

{$R *.RES}

uses
  Windows,
  ContPlug,
  SysUtils,
  FileProc in 'FileProc.pas',
  LockApp in 'LockApp.pas';

const
  _FieldsNum = 7;
  _Fields: array[0.._FieldsNum-1] of PChar =
    ('Unicode test', 'Locked test', 'Write test', 'Nearest Charset',
    'Nearest Charset Ex', 'ANSI Name', 'Lock App');

  _FieldTypes: array[0.._FieldsNum-1] of integer =
    (ft_multiplechoice, ft_multiplechoice, ft_multiplechoice, ft_string,
    ft_string, ft_string, ft_stringW);

  _FieldUnits: array[0.._FieldsNum-1] of PChar =
    ('ANSI|Partial Unicode|Pure Unicode|Invalid',
     'Access|Locked|Not found',
     'Access|Locked|Not found',
     '', '', '', '');

//--------------------------------------------
procedure StrLCpyA(p, p2: PAnsiChar; MaxLen: integer);
begin
  FillChar(p^, MaxLen, 0);
  lstrcpynA(p, p2, MaxLen);
end;

procedure StrLCpyW(p, p2: PWideChar; MaxLen: integer);
begin
  FillChar(p^, MaxLen, 0);
  lstrcpynW(p, p2, MaxLen);
end;

//--------------------------------------------
function ContentGetSupportedField(
  FieldIndex: integer;
  FieldName, Units: pAnsiChar;
  maxlen: integer): integer; stdcall;
begin
  if (FieldIndex<0) or (FieldIndex>=_FieldsNum) then
    begin Result:= FT_NOMOREFIELDS; Exit end;

  StrLCpyA(FieldName, PAnsiChar(Ansistring(_Fields[FieldIndex])), MaxLen);
  StrLCpyA(Units, PAnsiChar(Ansistring(_FieldUnits[FieldIndex])), MaxLen);
  Result:= _FieldTypes[FieldIndex];
end;

//--------------------------------------------
function ContentGetValue(
  fn: pAnsiChar;
  FieldIndex, UnitIndex: integer;
  FieldValue: PAnsiChar;
  maxlen, flags: integer): integer; stdcall;
begin
  Result:= ft_fieldempty;
end;

function ContentGetValueW(
  fn: pWideChar;
  FieldIndex, UnitIndex: integer;
  FieldValue: PByte;
  maxlen, flags: integer): integer; stdcall;
var
  s: string;
begin
  if (FieldIndex<0) or (FieldIndex>=_FieldsNum) then
    begin Result:= FT_NOSUCHFIELD; Exit end;

  case FieldIndex of
    0: s:= SUnicodeTest[FUnicodeTest(fn)];
    1: s:= SAccessTest[FReadTest(fn)];
    2: s:= SAccessTest[FWriteTest(fn)];
    3: s:= SUnicodeTest[FUnicodeTestEx(fn)];
    4:begin
        s := SUnicodeTest[FUnicodeTestEx(fn)];
        s := s + ' (' + SUnicodeTest[FUnicodeTest(fn, False)] + ')';
      end;
    5: s := AnsiString(StringReplace(AnsiString(ExtractFileName(fn)), '?', '_', [rfReplaceAll]));
    6: s := FLockApp(fn);
  end;

  if s='' then
    Result:= ft_fieldempty
  else
  begin
    case FieldIndex of
      6: StrLCopy(PWideChar(FieldValue), PWideChar(s), maxlen div 2 - 2);
    else
      StrLCpyA(PAnsiChar(FieldValue), PAnsiChar(Ansistring(s)), MaxLen {div 2});
    end;
    Result:= _FieldTypes[FieldIndex];
  end;
end;

exports
  ContentGetSupportedField,
  ContentGetValue,
  ContentGetValueW;

end.
